//This file contain SPEA2 implementation for multi-objective optimization
//Programmed by NXH
//#include<conio.h>//Delete this line if you are in Unix
#include<iostream.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<assert.h>
#include "gconst.h"
#include "random.h"
#include "stree.h"
#include "lexicon.h"
#include "adtable.h"
#include  "dtree.h"
#include "genetic.h"
//#include "mulplex.h"
#include "symreg.h"
#include "spea2.h"
FILE *fpkey;
int cmldtype;
char cmloutpop[80],cmloutpar[80],cmloutstat[80],cmlkey[80];
//*****************************************************
//This Function initializes for the program           *
//*****************************************************
void Init()
{
 //Initialize global variables
 //Loading Elementary trees and Adjoining Table
  LoadEtree();
 //Initialize population
  poplen=1000;
  alen=1000;
  oldpop=new pindividual[poplen+alen];assert(oldpop!=NULL);
  newpop=new pindividual[poplen+alen];assert(newpop!=NULL);
 // oldarchive=new pindividual[alen];assert(oldpop!=NULL);
  //newarchive=new pindividual[poplen];assert(newpop!=NULL);
 //Initialize Probabilities
  pcross=0.9;
  preplace=0.1;
  pdelete=0;
  pinsert=0;
  pmutate=0;
  prep=0;
  ptran=0;
//Initializes satistics
  ncross=0;
  nreplace=0;
  ninsert=0;
  ndelete=0;
  nmutate=0;
  nrep=0;
  ntran=0;
//Number of generations
  generation=26;
  bestcurrent=new individual[generation];assert(bestcurrent!=NULL);
  averagefitness=new double[generation];assert(averagefitness!=NULL);
  averagesfitness=new double[generation];assert(averagesfitness!=NULL);
  averagesize=new double[generation];assert(averagesize!=NULL);
//Some global variables
  SuccPredicate=FALSE;
  _cut=TRUE;
  strongdominance=cmldtype;
//Set up fitness cases
//  SetFitCase();
}
void pitoa(int i, char *ch)
{
 int j,k;
 char s[10],s1[10];
 k=10;
 strcpy(s,"");
 while(i>0)
  {
   j=i % k;
   s1[0]=j+'0';
   s1[1]=0;
   strcat(s1,s);
   strcpy(s,s1);
   i=i/k;
  }
 strcpy(ch, s);
}
FILE *Open_Text_File(char *filename)
{
 FILE *f;
 f=fopen(filename,"wt");
 if(f==NULL)
  {
   cout<<endl<<"File Creation error"<<endl;
   exit(1);
  }
 return f;
}
main(int argc, char *argv[])
{
 int i,pos,j,runs,size,min2;
 char temp[10];
 char outpop[80],outpar[80],outstat[80];
 double min;
 long seed;
 stree s,s1;
 if(argc!=6)
  {
   cout<<endl<<"Commandline Parameter Missing:"<<endl;
   cout<<"1- Key Filename"<<endl;
   cout<<"2- Output Population file name"<<endl;
   cout<<"3- Output Pareto filename"<<endl;
   cout<<"4- Output Statistic File Name:"<<endl;
   cout<<"5- Pareto Dominance Type";
   exit(1);
  }
 strcpy(cmlkey,argv[1]);
 fpkey=fopen(cmlkey,"rt");
 if(fpkey==NULL)
  {
   cout<<endl<<"Can not read the key file!"<<endl;
   exit(1);
  }
 strcpy(cmloutpop,argv[2]);
 strcpy(cmloutpar,argv[3]);
 strcpy(cmloutstat,argv[4]);
 cmldtype=atoi(argv[5]);
 Init();
//InitRanGen();
//read the number of keys
 fscanf(fpkey,"%d%*c",&runs);
for(i=1;i<=runs;i++)
{
 InitRanGen();
 fscanf(fpkey,"%d%*c",&j);
 seed=j;
 pitoa(j,temp);
 strcpy(outpop,cmloutpop);
 strcat(outpop,temp);
 fppop=Open_Text_File(outpop);
 strcpy(outpar,cmloutpar);
 strcat(outpar,temp);
 fppar=Open_Text_File(outpar);
 strcpy(outstat,cmloutstat);
 strcat(outstat,temp);
 fpstat=Open_Text_File(outstat);
 Set_Seed(seed);//some (in many) other keys for successful induction of
 SetFitCase();
 Evolution();
 for(j=0;j<gen;j++)
  {
   s=Decode(bestcurrent[j],FALSE);
   s1.root=Stree2ParseTree(s.root);
   s1.foot=NULL;
   size=GetSize(s1,TRUE);
   DeleteTree(s);
   DeleteTree(s1);
   fprintf(fpstat,"%lf %d %lf %lf %lf\n",bestcurrent[j].fitness,size,averagefitness[j],averagesfitness[j],averagesize[j]);
  }
 min=bestcurrent[0].fitness;
 pos=0;
 for(j=1;j<gen;j++)
   if(bestcurrent[j].fitness<min)
    {
     min=bestcurrent[j].fitness;
     pos=j;
    }
//with respect to the secondary fitness
   s=Decode(bestcurrent[pos],FALSE);
   s1.root=Stree2ParseTree(s.root);
   s1.foot=NULL;
   min2=GetSize(s1,TRUE);
   DeleteTree(s);
   DeleteTree(s1);
for(j=0;j<gen;j++)
 if(bestcurrent[j].fitness==min)
   {
    s=Decode(bestcurrent[j],FALSE);
    s1.root=Stree2ParseTree(s.root);
    s1.foot=NULL;
    size=GetSize(s1,TRUE);
    DeleteTree(s);
    DeleteTree(s1);
    if(size<min2)
     {
      min2=size;
      pos=j;
     }
   }
  fprintf(fpstat,"The best found at generation: %d\n",pos);
 // DeleteIntron(bestcurrent[pos]);
  fprintf(fpstat,"Fitness %lf and Size %d\n",bestcurrent[pos].fitness,min2);
  fprintf(fpstat,"Number of crossover:%ld\n",ncross);
  fprintf(fpstat,"Number of Replacement:%ld\n",nreplace);
  fclose(fppop);
  fclose(fppar);
  fclose(fpstat);
 }
fclose(fpkey);
}
